<template>
  <div class="mt-2 flex-column dsd-feature">
    <div>
      <dataset-details-feature-header
        :title="`EuroVoc Descriptors (${
          getSubject ? getSubject.length.toLocaleString('fi') : 0
        })`"
        :arrowDown="!expanded"
        tag="keywords-toggle"
        :onClick="toggleExpanded"
        class="ml-0"
      />
    </div>
    <div v-if="expanded" class="keywords__item row mt-4">
      <span
        v-for="(subject, i) in displayedSubjects"
        :key="i"
        class="col-6 col-sm-3 col-md-2 mt-md-0 mt-3 mb-2 mx-0 px-1"
      >
        <app-link :to="getSubjectLink(subject)">
          <small
            v-if="typeof subject.title === 'object'"
            class="d-inline-block w-100 py-2 rounded-pill text-center text-white subject"
          >
            <span v-for="(value, key) in subject.title" :key="key">
              <tooltip :title="value" data-placement="top">
                {{ truncate(value, maxSubjectLength, false) }}
              </tooltip>
            </span>
          </small>
          <small
            v-else-if="typeof subject.title === 'string'"
            class="d-inline-block w-100 py-2 rounded-pill text-center text-white subject"
          >
            <span>
              <tooltip :title="subject.title" data-placement="top">
                {{ truncate(subject.title, maxSubjectLength, false) }}
              </tooltip>
            </span>
          </small>
        </app-link>
      </span>
    </div>
    <div v-if="expanded && displayedSubjects.length > defaultDisplayCount">
      <pv-show-more
        :label="isSubjectAllDisplayed ? $t('message.metadata.showLess') : $t('message.metadata.showMore')"
        :upArrow="isSubjectAllDisplayed"
        :action="toggleDisplayCount"
        class="row text-primary"
      />
    </div>
  </div>
</template>

<script>
import { truncate } from "../../utils/helpers";
import { has } from "lodash";
import { mapGetters } from "vuex";
import Tooltip from "../../widgets/Tooltip";
import AppLink from "../../widgets/AppLink";
import { sortAlphabetically } from "./utils/sortAlphabetically";
import $ from "jquery";

export default {
  name: "DatasetDetailsSubject",
  components: { Tooltip, AppLink },
  data() {
    return {
      showTitle: this.$env.content.datasetDetails.keywords.showTitle,
      maxSubjectLength: this.$env.content.datasets.maxKeywordLength,
      defaultDisplayCount: 24,
      followSubjectLinks: this.$env.content.datasets.followSubjectLinks,
      expanded: false, // Toggle state
      subject: {
        displayAll: false,
        displayCount: 24,
        incrementSteps: [12, 60],
      },
    };
  },
  computed: {
    ...mapGetters("datasetDetails", ["getSubject"]),
    displayedSubjects() {
      const subjects = this.subject.displayAll
        ? Object.freeze(this.sortedSubject)
        : Object.freeze(this.sortedSubject.slice(0, this.subject.displayCount));
      return subjects.filter((subject) => subject.title);
    },
    isSubjectAllDisplayed() {
      return this.subject.displayCount >= this.displayedSubjects.length;
    },
    sortedSubject() {
      let selected = [];
      const selectedLanguage = this.$route.query.locale;

      this.getSubject.forEach((element) => {
        if (has(element, "title") && element.title !== null) {
          if (typeof element.title === "object") {
            Object.keys(element.title).forEach((key) => {
              if (key !== selectedLanguage) {
                delete element.title[key];
              }
            });
          }
          selected.push(element);
        }
      });
      this.sortAlphabetically(selected, "title", selectedLanguage);
      return selected;
    },
  },
  methods: {
    truncate,
    sortAlphabetically,
    toggleDisplayCount() {
      $('body').tooltip({ selector: '[data-toggle="tooltip"]' });
      if (this.subject.displayCount < this.getSubject.length) {
        this.subject.displayCount = this.getSubject.length;
      } else {
        this.subject.displayCount = this.defaultDisplayCount;
      }
      this.subject.displayAll = !this.subject.displayAll;
    },
    toggleExpanded() {
      this.expanded = !this.expanded; // Toggle visibility
    },
    getSubjectLink(subject) {
      const urlResource = subject.id;
      return {
        path: `/datasets`,
        query: {
          locale: this.$route.query.locale,
          subject: urlResource,
        },
      };
    },
  },
};
</script>

<style scoped lang="scss">
.subject {
  background-color: #196fd2;
}

.keywords-header {
  justify-content: flex-start; /* Aligned header to the left */
}

.keywords-header .keywords-toggle {
  margin-left: 0; /* The toggle header is on the left */
}
</style>
